Subject: Re: [PATCH 00/14] Swap-over-NBD without deadlocking v5

From: Mel Gorman <[email-masked]>
Date: Fri, 15 Jul 2011 15:10:21 +0100

On Thu, Jul 07, 2011 at 08:58:31AM -0400, Christoph Hellwig wrote:
> On Thu, Jul 07, 2011 at 10:47:37AM +0100, Mel Gorman wrote:
> > Additional complexity is required for swap-over-NFS but affects the
> > core kernel far less than this series. I do not have a series prepared
> > but from what's in a distro kernel, supporting NFS requires extending
> > address_space_operations for swapfile activation/deactivation with
> > some minor helpers and the bulk of the remaining complexity within
> > NFS itself.
> 
> The biggest addition for swap over NFS is to add proper support for
> a filesystem interface to do I/O on random kernel pages instead of
> the current nasty bmap hack the swapfile code is using. Splitting
> that work from all the required VM infrastructure should make life
> easier for everyone involved and allows merging it independeny as
> both bits have other uses case as well.
> 

The swap-over-nfs patches allows this possibility. There is a swapon
interface added that could be used by the filesystem to ensure the
underlying blocks are allocated and a swap_out/swap_in interface that
takes a struct file, struct page and writeback_control. This would
be an alternative to bmap being used to record the blocks backing
each extent.

Any objection to the swap-over-NBD stuff going ahead to get part of the
complexity out of the way?

-- 
Mel Gorman
SUSE Labs

--
To unsubscribe, send a message with 'unsubscribe linux-mm' in
the body to [email-masked].  For more info on Linux MM,
see: http://www.linux-mm.org/ .
Fight unfair telecom internet charges in Canada: sign http://stopthemeter.ca/
Don't email: <a href=mailto:"[email-masked]"> [email-masked] </a>